### GET /deployables Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Returns a list of all the types and associated major versions of database deployments that can be provisioned. ```markdown ### Responses #### 200 - Deployable database objects - **deployables** (array (Deployables)) Array items: - **type** (string): Deployment type - typically the name of the database (example: "elasticsearch") - **versions** (array (object)): An array of versions of the database, their status, preferedness, and transitions Array items: - **version** (string): The version number (example: "5.6") - **status** (string (deprecated|beta|stable)): The status of this version: To be finalized (example: "stable") ("deprecated"|"beta"|"stable") - **is_preferred** (boolean): Should this version be preferred over others? (example: true) - **transitions** (array (object)): versions that this version can be upgraded to Array items: - **application** (string): The database type (example: "elasticsearch") - **method** (string): in-place or restore method of going from from_version to to_version (example: "restore") - **skip_backup_supported** (boolean): Option to upgrade instance without taking a backup. (example: false) - **from_version** (string): The version the transition in from (example: "5.6") - **to_version** (string): The version the transition is to (example: "6.7") #### 403 - Invalid token Invalid token ### Example Usage ```bash curl -X GET "https://api.{region}.databases.cloud.ibm.com/v5/{platform}/deployables" ``` ``` -------------------------------- ### POST /deployments/{id}/elasticsearch/file_syncs Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Starts a task that writes files to disk. Available for Elasticsearch ONLY. ```markdown ### Parameters - **id** (string, path, required): Deployment ID ### Responses #### 200 - A task - **task** (object) - **id** (string): ID of the task. - **resource_type** (string (backup|ip|user|password|instance|configuration|upgrade)): The resource type of the task ("backup"|"ip"|"user"|"password"|"instance"|"configuration"|"upgrade") - **description** (string): Human-readable description of the task. - **status** (string (queued|running|completed|failed|expired)): The status of the task. ("queued"|"running"|"completed"|"failed"|"expired") - **deployment_id** (string): ID of the deployment the task is being performed on. - **progress_percent** (integer (int32)): Indicator as percentage of progress of the task. - **created_at** (string (date-time)): Date and time when the task was created. #### 403 - Invalid token Invalid token #### 404 - not found not found ### Example Usage ```bash curl -X POST "https://api.{region}.databases.cloud.ibm.com/v5/{platform}/deployments/{id}/elasticsearch/file_syncs" ``` ``` -------------------------------- ### GET /deployments/{id}/backups Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Get details of all currently available backups from a deployment. ```markdown ### Parameters - **id** (string, path, required): Deployment ID ### Responses #### 200 - An array of backups **Backups** - **backups** (array (Backup)): An array of backups. Array items: - **id** (string): ID of this backup. (example: "5a970218cb7544000671c094") - **deployment_id** (string): ID of the deployment this backup relates to. (example: "595eada310b7ac00116dd48b") - **type** (string (scheduled|on_demand)): The type of backup. (example: "scheduled") ("scheduled"|"on_demand") - **status** (string (running|completed|failed)): The status of this backup. (example: "running") ("running"|"completed"|"failed") - **is_downloadable** (boolean): Is this backup available to download? (example: true) - **is_restorable** (boolean): Can this backup be used to restore an instance? (example: true) - **download_link** (string): URI which is currently available for file downloading (example: "https://securedownloadservice.com/backup-2018-02-28T19:25:12Z.tgz") - **created_at** (string (date-time)): Date and time when this backup was created. (example: "2018-02-28T19:25:12Z") #### 403 - Invalid token Invalid token ### Example Usage ```bash curl -X GET "https://api.{region}.databases.cloud.ibm.com/v5/{platform}/deployments/{id}/backups" ``` ``` -------------------------------- ### GET /deployments/{id}/users/{user_type}/{user_id}/connections Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Discover connection information for a deployment for a user. ```markdown ### Parameters - **id** (string, path, required): Deployment ID - **user_type** (string, path, required): User type - **user_id** (string, path, required): User ID - **certificate_root** (string, query, optional): Optional certificate root path to prepend certificate names. Certificates would be stored in this directory for use by other commands. ### Responses #### 200 - A Connection #### 403 - Invalid token Invalid token ### Example Usage ```bash curl -X GET "https://api.{region}.databases.cloud.ibm.com/v5/{platform}/deployments/{id}/users/{user_type}/{user_id}/connections?certificate_root=string" ``` ``` -------------------------------- ### GET /deployments/{id}/capability/{capability_id} Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Returns capability information based on the deployment provided. Also returns url parameters or defaults if request parameters are blank. ```markdown ### Parameters - **id** (string, path, required): Deployment ID - **capability_id** (string (autoscaling|encryption|endpoints|groups|locations|point_in_time_recovery|remotes|versions), path, required): Capability ID - **target_platform** (string, query, optional): Target platform. Required for Point In Time Recovery. - **target_location** (string, query, optional): Target location. Required for Point In Time Recovery. - **host_flavor** (string, query, optional): When a host_flavor of 'multitenant' is included with the request, IBM Cloud Database's new shared compute groups will be returned - **include_hidden** (boolean, query, optional): Include hidden versions. Only applicable for versions capability. (example: true) - **include_beta** (boolean, query, optional): Include beta versions. Only applicable for versions capability. (example: true) ### Responses #### 200 - capability information - **capability** (object) - **autoscaling** (object) - **autoscaling_supported** (boolean): Autoscaling capability. (example: true) - **encryption** (object) - **disk_encryption_supported** (boolean): Disk encryption capability. (example: true) - **endpoints** (object) - **direct_endpoints_supported** (boolean): Direct endpoints capability. (example: false) - **public_endpoints_supported** (boolean): Public endpoints capability. (example: true) - **private_endpoints_supported** (boolean): Private endpoints capability. (example: true) - **multiple_endpoints_supported** (boolean): Multiple endpoints capability. (example: true) - **groups** (array (Group)) Array items: - **id** (string (member|search|bi_connector|analytics)): Id/name for group (example: "member") ("member"|"search"|"bi_connector"|"analytics") - **count** (integer): Number of entities in the group (example: 2) - **members** (object) - **units** (string): Units used for scaling number of members (example: "count") - **allocation_count** (integer): Allocated number of members (example: 2) - **minimum_count** (integer): Minimum number of members (example: 2) - **maximum_count** (integer): Maximum number of members (example: 20) - **step_size_count** (integer): Step size for number of members (example: 1) - **is_adjustable** (boolean): Is this deployment's number of members adjustable? (example: true) - **is_optional** (boolean): Is this deployments's number of members optional? (example: false) - **can_scale_down** (boolean): Can this deployment's number of members scale down? (example: false) - **memory** (object) - **units** (string): Units used for scaling memory (example: "mb") - **allocation_mb** (integer): Allocated memory in MB (example: 12288) - **minimum_mb** (integer): Minimum memory in MB (example: 1024) - **maximum_mb** (integer): Maximum memory in MB (example: 114688) - **step_size_mb** (integer): Step size memory can be adjusted by in MB (example: 1024) - **is_adjustable** (boolean): Is this group's memory adjustable? (example: true) - **is_optional** (boolean): Is this group's memory optional? (example: false) - **can_scale_down** (boolean): Can this group's memory scale down? (example: true) - **cpu_enforcement_ratio_ceiling_mb** (integer): The amount of memory required before the cpu/memory ratio is no longer enforced. (multitenant only) (example: 16384) - **cpu_enforcement_ratio_mb** (integer): The maximum memory allowed per CPU until the ratio ceiling is reached. (multitenant only) (example: 8192) - **cpu** (object) - **disk** (object) - **host_flavor** (object) - **id** (string): Group's host flavor id (example: "b3c.4x16.encrypted") - **name** (string): Group's hostflavor name (example: "4x16") - **hosting_size** (string): Group's host flavor size (example: "xs") - **flavors** (array (object)) Array items: - **id** (string): Host flavor id (example: "b3c.4x16.encrypted") - **name** (string): Host flavor name (example: "4x16") - **cpu** (object) - **allocation_count** (integer): Allocated number of cpus (example: 2) - **memory** (object) - **allocation_mb** (integer): Allocated memory in MB (example: 12288) - **hosting_size** (string): Host flavor size (example: "xs") - **locations** (object) - **locations** (array (string)): An array of regions and satellite locations. - **point_in_time_recovery** (object) - **point_in_time_recovery_supported** (boolean): Point in time recovery capability. (example: true) - **remotes** (object) - **read_only_replicas_supported** (boolean): Read-only replica capability. (example: true) - **restores** (object): Only available for requests with Backup. Only available capability for Backup requests. - **backup_restore_supported** (boolean): Backup restore capability. (example: true) - **versions** (array (object)): An array of versions of the database, their status, preferedness, and transitions Array items: - **type** (string): The database type (example: "elasticsearch") - **version** (string): The version number (example: "5.6") - **status** (string (deprecated|beta|stable)): The status of this version: To be finalized (example: "stable") ("deprecated"|"beta"|"stable") - **is_preferred** (boolean): Should this version be preferred over others? (example: true) - **transitions** (array (object)): versions that this version can be upgraded to Array items: - **application** (string): The database type (example: "elasticsearch") - **method** (string): method of going from from_version to to_version (example: "restore") - **skip_backup_supported** (boolean): Option to upgrade instance without taking a backup. (example: false) - **from_version** (string): The version the transition in from (example: "5.6") - **to_version** (string): The version the transition is to (example: "6.7") #### 403 - Invalid token #### 422 - Unprocessable Entity ### Example Usage ```bash curl -X GET "https://api.{region}.databases.cloud.ibm.com/v5/{platform}/deployments/{id}/capability/{capability_id}?target_platform=string&target_location=string&host_flavor=string&include_hidden=true&include_beta=true" ``` ``` -------------------------------- ### GET /deployments/{id} Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Gets the full data that is associated with a deployment. This data includes the ID, name, database type, and version. ```markdown ### Parameters - **id** (string, path, required): Deployment ID ### Responses #### 200 - A deployment response - **deployment** (object) - **id** (string): ID of this deployment. (example: "crn:v1:bluemix:public:databases-for-redis:us-south:a/274074dce64e9c423ffc238516c755e1:29caf0e7-120f-4da8-9551-3abf57ebcfc7::") - **name** (string): Readable name of this deployment. (example: "crn:v1:bluemix:public:databases-for-redis:us-south:a/274074dce64e9c423ffc238516c755e1:29caf0e7-120f-4da8-9551-3abf57ebcfc7::") - **type** (string): Database type within this deployment. (example: "redis") - **platform** (string): Platform for this deployment. (example: "satellite, classic") - **platform_options** (object): Platform-specific options for this deployment. - **version** (string): Version number of the database. (example: "4") - **admin_usernames** (object): Login name of administration level user. - **enable_public_endpoints** (boolean): Whether access to this deployment is enabled from the public internet. This property can be modified by updating this service instance through the Resource Controller API. (example: true) - **enable_private_endpoints** (boolean): Whether access to this deployment is enabled from IBM Cloud via the IBM Cloud backbone network. This property can be modified by updating this service instance through the Resource Controller API. (example: false) #### 403 - Invalid token Invalid token ### Example Usage ```bash curl -X GET "https://api.{region}.databases.cloud.ibm.com/v5/{platform}/deployments/{id}" ``` ``` -------------------------------- ### POST /deployments/{id}/users/{user_type}/{user_id}/connections Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Discover connection information for a deployment for a user. Behaves the same as the GET method but substitutes the given password parameter into the returned connection information. ```markdown ### Parameters - **id** (string, path, required): Deployment ID - **user_type** (string, path, required): User type - **user_id** (string, path, required): User ID ### Request Body **Content-Type:** application/json - **password** (string): Password to be substituted into the response - **certificate_root** (string): Optional certificate root path to prepend certificate names. Certificates would be stored in this directory for use by other commands. ### Responses #### 200 - A Connection #### 403 - Invalid token Invalid token #### 422 - An error message response **Errors** - **errors** (object) ### Example Usage ```bash curl -X POST "https://api.{region}.databases.cloud.ibm.com/v5/{platform}/deployments/{id}/users/{user_type}/{user_id}/connections" \ -H "Content-Type: application/json" \ -d '{ "password": "string", "certificate_root": "string" }' ``` ``` -------------------------------- ### GET /deployments/{id}/configuration/schema Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Get the schema of the database configuration. Available for PostgreSQL and Redis ONLY. ```markdown ### Parameters - **id** (string, path, required): Deployment ID ### Responses #### 200 - A database configuration schema #### 403 - Invalid token Invalid token #### 404 - not found not found ### Example Usage ```bash curl -X GET "https://api.{region}.databases.cloud.ibm.com/v5/{platform}/deployments/{id}/configuration/schema" ``` ``` -------------------------------- ### GET /backups/{backup_id}/capability/{capability_id} Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Returns capability information based on the backup provided. Also returns url parameters or defaults if request parameters are blank. ```markdown ### Parameters - **backup_id** (string, path, required): Backup ID - **capability_id** (string (restores), path, required): Capability ID - **target_platform** (string, query, optional): Target platform. - **target_location** (string, query, optional): Target location. - **host_flavor** (string, query, optional): When a host_flavor of 'multitenant' is included with the request, IBM Cloud Database's new shared compute groups will be returned ### Responses #### 200 - capability information - **capability** (object) - **autoscaling** (object) - **autoscaling_supported** (boolean): Autoscaling capability. (example: true) - **encryption** (object) - **disk_encryption_supported** (boolean): Disk encryption capability. (example: true) - **endpoints** (object) - **direct_endpoints_supported** (boolean): Direct endpoints capability. (example: false) - **public_endpoints_supported** (boolean): Public endpoints capability. (example: true) - **private_endpoints_supported** (boolean): Private endpoints capability. (example: true) - **multiple_endpoints_supported** (boolean): Multiple endpoints capability. (example: true) - **groups** (array (Group)) Array items: - **id** (string (member|search|bi_connector|analytics)): Id/name for group (example: "member") ("member"|"search"|"bi_connector"|"analytics") - **count** (integer): Number of entities in the group (example: 2) - **members** (object) - **units** (string): Units used for scaling number of members (example: "count") - **allocation_count** (integer): Allocated number of members (example: 2) - **minimum_count** (integer): Minimum number of members (example: 2) - **maximum_count** (integer): Maximum number of members (example: 20) - **step_size_count** (integer): Step size for number of members (example: 1) - **is_adjustable** (boolean): Is this deployment's number of members adjustable? (example: true) - **is_optional** (boolean): Is this deployments's number of members optional? (example: false) - **can_scale_down** (boolean): Can this deployment's number of members scale down? (example: false) - **memory** (object) - **units** (string): Units used for scaling memory (example: "mb") - **allocation_mb** (integer): Allocated memory in MB (example: 12288) - **minimum_mb** (integer): Minimum memory in MB (example: 1024) - **maximum_mb** (integer): Maximum memory in MB (example: 114688) - **step_size_mb** (integer): Step size memory can be adjusted by in MB (example: 1024) - **is_adjustable** (boolean): Is this group's memory adjustable? (example: true) - **is_optional** (boolean): Is this group's memory optional? (example: false) - **can_scale_down** (boolean): Can this group's memory scale down? (example: true) - **cpu_enforcement_ratio_ceiling_mb** (integer): The amount of memory required before the cpu/memory ratio is no longer enforced. (multitenant only) (example: 16384) - **cpu_enforcement_ratio_mb** (integer): The maximum memory allowed per CPU until the ratio ceiling is reached. (multitenant only) (example: 8192) - **cpu** (object) - **disk** (object) - **host_flavor** (object) - **id** (string): Group's host flavor id (example: "b3c.4x16.encrypted") - **name** (string): Group's hostflavor name (example: "4x16") - **hosting_size** (string): Group's host flavor size (example: "xs") - **flavors** (array (object)) Array items: - **id** (string): Host flavor id (example: "b3c.4x16.encrypted") - **name** (string): Host flavor name (example: "4x16") - **cpu** (object) - **allocation_count** (integer): Allocated number of cpus (example: 2) - **memory** (object) - **allocation_mb** (integer): Allocated memory in MB (example: 12288) - **hosting_size** (string): Host flavor size (example: "xs") - **locations** (object) - **locations** (array (string)): An array of regions and satellite locations. - **point_in_time_recovery** (object) - **point_in_time_recovery_supported** (boolean): Point in time recovery capability. (example: true) - **remotes** (object) - **read_only_replicas_supported** (boolean): Read-only replica capability. (example: true) - **restores** (object): Only available for requests with Backup. Only available capability for Backup requests. - **backup_restore_supported** (boolean): Backup restore capability. (example: true) - **versions** (array (object)): An array of versions of the database, their status, preferedness, and transitions Array items: - **type** (string): The database type (example: "elasticsearch") - **version** (string): The version number (example: "5.6") - **status** (string (deprecated|beta|stable)): The status of this version: To be finalized (example: "stable") ("deprecated"|"beta"|"stable") - **is_preferred** (boolean): Should this version be preferred over others? (example: true) - **transitions** (array (object)): versions that this version can be upgraded to Array items: - **application** (string): The database type (example: "elasticsearch") - **method** (string): method of going from from_version to to_version (example: "restore") - **skip_backup_supported** (boolean): Option to upgrade instance without taking a backup. (example: false) - **from_version** (string): The version the transition in from (example: "5.6") - **to_version** (string): The version the transition is to (example: "6.7") #### 403 - Invalid token #### 422 - Unprocessable Entity ### Example Usage ```bash curl -X GET "https://api.{region}.databases.cloud.ibm.com/v5/{platform}/backups/{backup_id}/capability/{capability_id}?target_platform=string&target_location=string&host_flavor=string" ``` ``` -------------------------------- ### GET /backups/{backup_id} Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Get information about a backup, such as creation date. ```markdown ### Parameters - **backup_id** (string, path, required): Backup ID ### Responses #### 200 - A backup response - **backup** (object) - **id** (string): ID of this backup. (example: "5a970218cb7544000671c094") - **deployment_id** (string): ID of the deployment this backup relates to. (example: "595eada310b7ac00116dd48b") - **type** (string (scheduled|on_demand)): The type of backup. (example: "scheduled") ("scheduled"|"on_demand") - **status** (string (running|completed|failed)): The status of this backup. (example: "running") ("running"|"completed"|"failed") - **is_downloadable** (boolean): Is this backup available to download? (example: true) - **is_restorable** (boolean): Can this backup be used to restore an instance? (example: true) - **download_link** (string): URI which is currently available for file downloading (example: "https://securedownloadservice.com/backup-2018-02-28T19:25:12Z.tgz") - **created_at** (string (date-time)): Date and time when this backup was created. (example: "2018-02-28T19:25:12Z") #### 403 - Invalid token Invalid token ### Example Usage ```bash curl -X GET "https://api.{region}.databases.cloud.ibm.com/v5/{platform}/backups/{backup_id}" ``` ``` -------------------------------- ### POST /deployments/{id}/users/{user_type}/{user_id}/connections/{endpoint_type} Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Discover connection information for a deployment for a user. Behaves the same as the GET method but substitutes the provided password parameter into the returned connection information. ```markdown ### Parameters - **id** (string, path, required): Deployment ID - **user_type** (string, path, required): User type of `database` is the only currently supported value. - **user_id** (string, path, required): User ID - **endpoint_type** (string (public|private), path, required): Endpoint Type. The select endpoint must be enabled on the deployment before its connection information can be fetched. ### Request Body **Content-Type:** application/json - **password** (string): Password to be substituted into the response - **certificate_root** (string): Optional certificate root path to prepend certificate names. Certificates would be stored in this directory for use by other commands. ### Responses #### 200 - A Connection #### 403 - Invalid token Invalid token #### 422 - An error message response **Errors** - **errors** (object) ### Example Usage ```bash curl -X POST "https://api.{region}.databases.cloud.ibm.com/v5/{platform}/deployments/{id}/users/{user_type}/{user_id}/connections/{endpoint_type}" \ -H "Content-Type: application/json" \ -d '{ "password": "string", "certificate_root": "string" }' ``` ``` -------------------------------- ### GET /deployments/{id}/allowlists/ip_addresses Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Retrieve the allowlisted addresses and ranges for a deployment. ```markdown ### Parameters - **id** (string, path, required): Deployment ID ### Responses #### 200 - An allowlist #### 403 - Invalid token Invalid token #### 422 - An error message response **Errors** - **errors** (object) ### Example Usage ```bash curl -X GET "https://api.{region}.databases.cloud.ibm.com/v5/{platform}/deployments/{id}/allowlists/ip_addresses" ``` ``` -------------------------------- ### GET /deployments/{id}/tasks Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Obtain a list of tasks currently running or recently run on a deployment. Tasks are ephemeral. Records of successful tasks are shown for 24-48 hours, and unsuccessful tasks are shown for 7-8 days. ```markdown ### Parameters - **id** (string, path, required): Deployment ID ### Responses #### 200 - An array of tasks - **tasks** (array (Task)) (example: [{"id":"crn:v1:bluemix:public:databases-for-postgresql:us-south:a/274074dce64e9c423ffc238516c755e1:a127f76a-98bf-4f8b-b263-01d9e16b15bd:task:3dc480bd-0cd9-4db6-92f4-b5c96544393b","resource_type":"backup","description":"Backing up database on-demand","status":"running","deployment_id":"crn:v1:bluemix:public:databases-for-postgresql:us-south:a/274074dce64e9c423ffc238516c755e1:a127f76a-98bf-4f8b-b263-01d9e16b15bd::","progress_percent":5,"created_at":"2018-03-28T10:31:30Z"}]) Array items: - **id** (string): ID of the task. - **resource_type** (string (backup|ip|user|password|instance|configuration|upgrade)): The resource type of the task ("backup"|"ip"|"user"|"password"|"instance"|"configuration"|"upgrade") - **description** (string): Human-readable description of the task. - **status** (string (queued|running|completed|failed|expired)): The status of the task. ("queued"|"running"|"completed"|"failed"|"expired") - **deployment_id** (string): ID of the deployment the task is being performed on. - **progress_percent** (integer (int32)): Indicator as percentage of progress of the task. - **created_at** (string (date-time)): Date and time when the task was created. #### 403 - Invalid token Invalid token ### Example Usage ```bash curl -X GET "https://api.{region}.databases.cloud.ibm.com/v5/{platform}/deployments/{id}/tasks" ``` ``` -------------------------------- ### GET /deployments/{id}/groups/{group_id}/autoscaling Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json The Autoscaling configuration represents the various conditions that control autoscaling for a deployment. This command allows for the retrieval of all autoscaling conditions for a particular deployment. ```markdown ### Parameters - **id** (string, path, required): Deployment ID - **group_id** (string, path, required): Group ID ### Responses #### 200 - An object containing autoscaling conditions **AutoscalingGroup** - **autoscaling** (object) (required) - **disk** (object) - **scalers** (object) - **capacity** (object) - **enabled** (boolean) (example: true) - **free_space_less_than_percent** (integer) (example: 10) - **io_utilization** (object) - **enabled** (boolean) (example: true) - **over_period** (string) (example: "30m") - **above_percent** (integer) (example: 45) - **rate** (object) - **increase_percent** (number) (example: 20) - **period_seconds** (integer) (example: 900) - **limit_mb_per_member** (number) (example: 3670016) - **units** (string) (example: "mb") - **memory** (object) - **cpu** (object) #### 403 - Invalid token Invalid token #### 404 - Not Found Not Found ### Example Usage ```bash curl -X GET "https://api.{region}.databases.cloud.ibm.com/v5/{platform}/deployments/{id}/groups/{group_id}/autoscaling" ``` ``` -------------------------------- ### GET /deployments/{id}/groups Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Scaling groups represent the various resources that are allocated to a deployment. This command allows for the retrieval of all of the groups for a particular deployment. ```markdown ### Parameters - **id** (string, path, required): Deployment ID ### Responses #### 200 - An array of scaling groups #### 403 - Invalid token Invalid token ### Example Usage ```bash curl -X GET "https://api.{region}.databases.cloud.ibm.com/v5/{platform}/deployments/{id}/groups" ``` ``` -------------------------------- ### GET /deployments/{id}/users/{user_id}/ Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Only for Redis v5 and prior: Discover connection information for a deployment for a user with an endpoint type. ```markdown ### Parameters - **id** (string, path, required): Deployment ID - **user_id** (string, path, required): User ID ### Responses #### 200 - User **Task** - **id** (string): ID of the task. - **resource_type** (string (backup|ip|user|password|instance|configuration|upgrade)): The resource type of the task ("backup"|"ip"|"user"|"password"|"instance"|"configuration"|"upgrade") - **description** (string): Human-readable description of the task. - **status** (string (queued|running|completed|failed|expired)): The status of the task. ("queued"|"running"|"completed"|"failed"|"expired") - **deployment_id** (string): ID of the deployment the task is being performed on. - **progress_percent** (integer (int32)): Indicator as percentage of progress of the task. - **created_at** (string (date-time)): Date and time when the task was created. #### 500 - Not Found Not Found ### Example Usage ```bash curl -X GET "https://api.{region}.databases.cloud.ibm.com/v5/{platform}/deployments/{id}/users/{user_id}/" ``` ``` -------------------------------- ### PUT /deployments/{id}/allowlists/ip_addresses Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Set the allowlist for a deployment. This action overwrites all existing entries, so when you modify the allowlist via a GET/update/PUT, provide the GET response's ETag header value in this endpoint's If-Match header to ensure that changes that are made by other clients are not accidentally overwritten. ```markdown ### Parameters - **id** (string, path, required): Deployment ID - **If-Match** (string, header, optional): Verify that the current allowlist matches a provided ETag value. Use in conjunction with the GET operation's ETag header to ensure synchronicity between clients. ### Request Body **Content-Type:** application/json ### Responses #### 202 - A task which is being run to add the allowlist entry - **task** (object) - **id** (string): ID of the task. - **resource_type** (string (backup|ip|user|password|instance|configuration|upgrade)): The resource type of the task ("backup"|"ip"|"user"|"password"|"instance"|"configuration"|"upgrade") - **description** (string): Human-readable description of the task. - **status** (string (queued|running|completed|failed|expired)): The status of the task. ("queued"|"running"|"completed"|"failed"|"expired") - **deployment_id** (string): ID of the deployment the task is being performed on. - **progress_percent** (integer (int32)): Indicator as percentage of progress of the task. - **created_at** (string (date-time)): Date and time when the task was created. #### 403 - Invalid token Invalid token #### 422 - An error message response **Errors** - **errors** (object) ### Example Usage ```bash curl -X PUT "https://api.{region}.databases.cloud.ibm.com/v5/{platform}/deployments/{id}/allowlists/ip_addresses" \ -H "Content-Type: application/json" \ -d '"value"' ``` ``` -------------------------------- ### GET /deployables/{type}/groups Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Scaling groups represent the various resources allocated to a deployment. When a new deployment is created, there are a set of defaults for each database type. This endpoint returns them for a particular database. ```markdown ### Parameters - **type** (string (postgresql|etcd), path, required): Database type name (example: "postgresql") - **host_flavor** (string (multitenant), query, optional): When a host_flavor of 'multitenant' is included with the request, IBM Cloud Database's new shared compute default groups will be returned (example: "multitenant") ### Responses #### 200 - An array of scaling groups #### 403 - Invalid token Invalid token ### Example Usage ```bash curl -X GET "https://api.{region}.databases.cloud.ibm.com/v5/{platform}/deployables/{type}/groups?host_flavor=multitenant" ``` ``` -------------------------------- ### Schema: Promotion Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Promotion and Upgrade options ```markdown ## Schema: Promotion Promotion and Upgrade options **Type:** object - **version** (string): Version number to upgrade to. - **skip_initial_backup** (boolean): Skip the initial backup of the deployment post-promotion. - **dry_run** (boolean): Validate upgrade success, DOES NOT run the promotion and upgrade. ``` -------------------------------- ### GET /deployments/{id}/remotes Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Get the read-only replicas associated with a deployment. Available for PostgreSQL and EnterpriseDB ONLY. ```markdown ### Parameters - **id** (string, path, required): Deployment ID ### Responses #### 200 - A remotes object - **remotes** (object): Remotes - **leader** (string): Leader ID, if applicable (example: "01f30581-54f8-41a4-8193-4a04cc022e9b-h") - **replicas** (array (string)): Replica IDs, if applicable (example: ["23h40521-57g6-31b5-9256-6b15df456f7j-g","g1d8g764-hngm-595j-7349450f3058-y"]) #### 403 - Invalid token Invalid token #### 404 - not found not found ### Example Usage ```bash curl -X GET "https://api.{region}.databases.cloud.ibm.com/v5/{platform}/deployments/{id}/remotes" ``` ``` -------------------------------- ### Schema: ConfigurationSchema Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Database Configuration Schema ```markdown ## Schema: ConfigurationSchema Database Configuration Schema **Type:** object - **archive_timeout** (object): Integer Property Schema - **customer_configurable** (boolean): Whether the setting is customer-configurable - **default** (integer): The default value of the setting - **default_description** (string): The description of the default value - **description** (string): The description of the setting - **kind** (string): The type of this setting (e.g., string, integer) - **requires_restart** (boolean): Whether or not changing this setting will restart the database - **min** (integer): The minimum value that this setting accepts - **max** (integer): The maximum value that this setting accepts - **step** (integer): The number that should be skipped between each step of a slider rendered for this setting - **deadlock_timeout** (object): Integer Property Schema - **effective_io_concurrency** (object): Integer Property Schema - **log_connections** (object): Choice Property Schema - **log_disconnections** (object): Choice Property Schema - **log_min_duration_statement** (object): Integer Property Schema - **max_connections** (object): Integer Property Schema - **max_locks_per_transaction** (object): Integer Property Schema - **max_prepared_transactions** (object): Integer Property Schema - **max_replication_slots** (object): Integer Property Schema - **max_wal_senders** (object): Integer Property Schema - **shared_buffers** (object): Integer Property Schema - **synchronous_commit** (object): Choice Property Schema - **tcp_keepalives_count** (object): Integer Property Schema - **tcp_keepalives_idle** (object): Integer Property Schema - **tcp_keepalives_interval** (object): Integer Property Schema - **wal_level** (object): Choice Property Schema ``` -------------------------------- ### GET /tasks/{id} Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Get information about a task and its status. Tasks themselves are persistent so old tasks can be consulted as well as running tasks. ```markdown ### Parameters - **id** (string, path, required): Task ID ### Responses #### 200 - A task - **task** (object) - **id** (string): ID of the task. - **resource_type** (string (backup|ip|user|password|instance|configuration|upgrade)): The resource type of the task ("backup"|"ip"|"user"|"password"|"instance"|"configuration"|"upgrade") - **description** (string): Human-readable description of the task. - **status** (string (queued|running|completed|failed|expired)): The status of the task. ("queued"|"running"|"completed"|"failed"|"expired") - **deployment_id** (string): ID of the deployment the task is being performed on. - **progress_percent** (integer (int32)): Indicator as percentage of progress of the task. - **created_at** (string (date-time)): Date and time when the task was created. #### 303 - A completed task redirects to the associated resource. - **task** (object) - **id** (string): ID of the task. - **resource_type** (string (backup|ip|user|password|instance|configuration|upgrade)): The resource type of the task ("backup"|"ip"|"user"|"password"|"instance"|"configuration"|"upgrade") - **description** (string): Human-readable description of the task. - **status** (string (queued|running|completed|failed|expired)): The status of the task. ("queued"|"running"|"completed"|"failed"|"expired") - **deployment_id** (string): ID of the deployment the task is being performed on. - **progress_percent** (integer (int32)): Indicator as percentage of progress of the task. - **created_at** (string (date-time)): Date and time when the task was created. #### 403 - Invalid token Invalid token ### Example Usage ```bash curl -X GET "https://api.{region}.databases.cloud.ibm.com/v5/{platform}/tasks/{id}" ``` ``` -------------------------------- ### Schema: RabbitMQConfiguration Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json MySQL Configuration ```markdown ## Schema: RabbitMQConfiguration MySQL Configuration **Type:** object - **delete_undefined_queues** (boolean): Automatically delete undefined queues. ``` -------------------------------- ### Schema: Deployables Source: https://cloud.ibm.com/apidocs/cloud-databases-api/cloud-databases-api-v5.json Deployable databases with their version information ```markdown ## Schema: Deployables Deployable databases with their version information **Type:** object - **type** (string): Deployment type - typically the name of the database (example: "elasticsearch") - **versions** (array (object)): An array of versions of the database, their status, preferedness, and transitions Array items: - **version** (string): The version number (example: "5.6") - **status** (string (deprecated|beta|stable)): The status of this version: To be finalized (example: "stable") ("deprecated"|"beta"|"stable") - **is_preferred** (boolean): Should this version be preferred over others? (example: true) - **transitions** (array (object)): versions that this version can be upgraded to Array items: - **application** (string): The database type (example: "elasticsearch") - **method** (string): in-place or restore method of going from from_version to to_version (example: "restore") - **skip_backup_supported** (boolean): Option to upgrade instance without taking a backup. (example: false) - **from_version** (string): The version the transition in from (example: "5.6") - **to_version** (string): The version the transition is to (example: "6.7") ```